﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using DataModel;
using P_PersonalDetails.Service.MedicalEmergency;
namespace P_PersonalDetails
{
    public partial class MedicalAndEmergency : UserControl
    {
        public MedicalAndEmergency()
        {
            InitializeComponent();
            try
            {
                SRV.LoadMedicalAndEMDataCompleted += new EventHandler<LoadMedicalAndEMDataCompletedEventArgs>(SRV_LoadMedicalAndEMDataCompleted);
            }
            catch (Exception)
            {
            }
        }

        void SRV_LoadMedicalAndEMDataCompleted(object sender, LoadMedicalAndEMDataCompletedEventArgs e)
        {
            this.DataContext = e.Result;
            e.Result.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(Result_PropertyChanged);
        }

        void Result_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            SRV.UpdatePropertyValueAsync((int)sender.GetPropertyValue("ID"), e.PropertyName, sender.GetPropertyValue(e.PropertyName));
        }

        public int? MemberID
        {
            get { return (int?)GetValue(MemberIDProperty); }
            set { SetValue(MemberIDProperty, value); }
        }

        // Using a DependencyProperty as the backing store for MemberID.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty MemberIDProperty =
            DependencyProperty.Register("MemberID", typeof(int?), typeof(MedicalAndEmergency), new PropertyMetadata(null, (DO, DE) =>
            {
                if (DE.NewValue != null)
                {
                    ((MedicalAndEmergency)DO).MemberIDChanged();
                }
            }));

        void MemberIDChanged()
        {
            SRV.LoadMedicalAndEMDataAsync(MemberID.Value);
        }

        MedicalEmergencyServiceClient SRV = ServiceConfig.NewMedicalAndEmergencyServiceClient();
    }
}
